require 'active_resource'

SITE = 'http://localhost:9282' unless defined?(SITE)

class Person < ActiveResource::Base
  self.site = SITE

  def family
    Family.find(self.surname.downcase)
  end

  def family=(family_surname)
    self.surname = family_surname
    Family.find(family_surname)
  rescue StandardError => e
    STDERR.puts("#{e.class.name}:#{e.message}\n#{e.backtrace.join("\n")}")
    Family.create(surname: family_surname.downcase)
  end
end

class Family < ActiveResource::Base
  self.site = SITE
end
