package main

import (
	"fmt"
	"net"

	"github.com/hypebeast/go-osc/osc"
)

func main() {
	// client := osc.NewClient("localhost", 9949)
	msg := osc.NewMessage("/osc/address")
	msg.Append(int32(111))
	msg.Append(true)
	msg.Append("hello")

	fmt.Printf("Sending: %#v\n", msg)
	// err := client.Send(msg)
	err := sendTCP(msg)
	if err != nil {
		fmt.Printf("ERROR: %#v\n", err)
	}
}

func sendTCP(packet osc.Packet) error {
	conn, err := net.Dial("tcp", "127.0.0.1:9949")
	if err != nil {
		return err
	}
	defer conn.Close()

	data, err := packet.ToByteArray()
	if err != nil {
		return err
	}

	_, err = conn.Write(data)
	if err != nil {
		return err
	}

	return nil
}
