require 'sylvilagus/ch02/hello_world'

class Sylvilagus::Ch02::HelloWorldConsumer < Java::ComRabbitmqClient::DefaultConsumer
  class << self
    include Sylvilagus::Ch02::HelloWorld::ClassMethods

    def main
      with_hello_world_channel do |channel|
        consumer = new(channel)

        STDERR.puts 'Starting consume loop...'
        channel.basic_consume('hello-queue', false, consumer)

        loop do
          sleep 1
          break if consumer.done?
        end
      end
    end
  end

  def done?
    @done ||= false
  end

  def handleDelivery(consumer_tag, envelope, properties, body)
    body_string = Java::OrgJruby::RubyString.bytes_to_string(body)

    puts "Consumed #{body_string.inspect}"
    channel.basic_ack(envelope.delivery_tag, false)

    if body_string == 'quit'
      STDERR.puts 'Quitting...'
      @done = true
    end
  end
end

if $0 == __FILE__
  Sylvilagus::Ch02::HelloWorldConsumer.main
end
