from __future__ import print_function

import logging
import sys

import pika

from sylvilagus.ch02 import hello_world


def main(sysargs=sys.argv[:]):
    msg = sysargs[1]

    logging.basicConfig()

    channel = hello_world.get_channel()

    if channel.basic_publish(
            body=msg,
            exchange='hello-exchange',
            properties=pika.BasicProperties(
                content_type='text/plain',
                delivery_mode=1
            ),
            routing_key='hola',
            mandatory=True):
        print('Message delivered!')
    else:
        print('Message returned!')

    channel.close()

    return 0


if __name__ == '__main__':
    sys.exit(main())
