package com.meatballhat.sylvilagus.ch02

import com.rabbitmq.client._

object HelloWorldConsumer extends App {
    val factory = new ConnectionFactory()
    factory.setUri(sys.env("SYLVILAGUS_AMQP_URI"))
    val connection = factory.newConnection
    val channel = connection.createChannel

    channel.exchangeDeclare("hello-exchange", "direct", true)
    channel.queueDeclare("hello-queue", false, false, false, null)

    var consumer = new QueueingConsumer(channel)
    channel.basicConsume("hello-queue", true, consumer)

    println("Waiting for messages...")

    while (true) {
        new String(consumer.nextDelivery.getBody) match {
            case "quit" => println("Exiting..") ; connection.close ; exit
            case msg@_ => println("Received '%s'".format(msg))
        }
    }
}
