package com.meatballhat.sylvilagus.ch02

import com.rabbitmq.client._

object HelloWorldProducer extends App {
    if (args.length < 1) {
        println("You must provide a message argument")
        exit
    }
    var messageBody = args(0)

    var factory = new ConnectionFactory()
    factory.setUri(sys.env("SYLVILAGUS_AMQP_URI"))
    var connection = factory.newConnection()
    var channel = connection.createChannel()

    channel.exchangeDeclare("hello-exchange", "direct", true)
    channel.queueDeclare("hello-queue", false, false, false, null)

    printf("Publishing '%s'\n", messageBody)
    channel.basicPublish("hello-exchange", "hola", null, messageBody.getBytes())

    connection.close()
}
